--
-- MobileAmpelExtras.lua
--
-- @author  Alex2009
-- @website www.alex2009.de
-- @date    16.02.2011
--
--Modifikation erst nach rcksprache mit dem Autor(Alex2009) erlaubt.
--Modification allowed only after consultation with the author(Alex2009).

MobileAmpelExtras = {};

function MobileAmpelExtras.prerequisitesPresent(specializations)
    return true
end;

function MobileAmpelExtras:load(xmlFile)
    self.setAmpelLightState = SpecializationUtil.callSpecializationsFunction("setAmpelLightState");
	self.Ampel = {};
	self.Ampel.index = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#index"));
	self.Ampel.rot = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Rot"));
	self.Ampel.orange = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Orange"));
	self.Ampel.gruen = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Gruen"));
    g_currentMission.nodeToVehicle[self.Ampel.index] = {};
	self.Ampelstate = false;
	self.ALightstate = 1;
    self.atime = 0;
end;

function MobileAmpelExtras:delete()
end;

function MobileAmpelExtras:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MobileAmpelExtras:keyEvent(unicode, sym, modifier, isDown)
end;

function MobileAmpelExtras:update(dt)
    if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.Ampel_AnAus) then
		    if not self.Ampelstate then
                self:setAmpelLightState(true,false,false);
		    else
                self:setAmpelLightState(false,false,false);
		    end;
	    end;
	end;
end;

function MobileAmpelExtras:updateTick(dt)
    if self.isServer then
        if self.Ampelstate then 
            self.atime = self.atime + dt;
            if self.atime > 20000 and self.ALightstate == 1 then
                self:setAmpelLightState(true,true,false);
                self.ALightstate = 2;
                self.atime = 0;
            elseif self.atime > 1200 and self.ALightstate == 2 then
                self:setAmpelLightState(false,false,true);
                self.ALightstate = 3;
                self.atime = 0;
            elseif self.atime > 20000 and self.ALightstate == 3 then
                self:setAmpelLightState(false,true,false);
                self.ALightstate = 4;
                self.atime = 0;
            elseif self.atime > 650 and self.ALightstate == 4 then
                self:setAmpelLightState(true,false,false);
                self.ALightstate = 1;
                self.atime = 0;
            end;
        end;
	end;
end;

function MobileAmpelExtras:readStream(streamId, connection)
    local red = streamReadBool(streamId);
    local orange = streamReadBool(streamId);
    local green = streamReadBool(streamId);
    self:setAmpelLightState(red,orange,green,true);
end;
 
function MobileAmpelExtras:writeStream(streamId, connection)
    streamWriteBool(streamId, self.Ampelstate);
    streamWriteBool(streamId, self.Ampelstate);
    streamWriteBool(streamId, self.Ampelstate);    
end;

function MobileAmpelExtras:setAmpelLightState(red,orange,green,noEventSend)
    setVisibility(self.Ampel.gruen, green);
    setVisibility(self.Ampel.orange, orange);
    setVisibility(self.Ampel.rot, red);
    local x, y, z = getTranslation(self.Ampel.index);
    if red then
        setTranslation(self.Ampel.index,4.37752,y,z);
    else
        setTranslation(self.Ampel.index,1.157,y,z);
    end;
    if not red and not orange and not green then
        setTranslation(self.Ampel.index,1.157,y,z);
        self.Ampelstate = false;
        self.ALightstate = 1;
        self.atime = 0;
    else
        self.Ampelstate = true;
    end;
    MobileAmpelExtrasEvent.sendEvent(self, red, orange, green, noEventSend);
end;
  
function MobileAmpelExtras:draw()
    if self.Ampelstate then
	    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelOff"), InputBinding.Ampel_AnAus);
	else
	    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelOn"), InputBinding.Ampel_AnAus);
	end;
end;

MobileAmpelExtrasEvent = {};
MobileAmpelExtrasEvent_mt = Class(MobileAmpelExtrasEvent, Event);

InitEventClass(MobileAmpelExtrasEvent, "MobileAmpelExtrasEvent");

function MobileAmpelExtrasEvent:emptyNew()
    local self = Event:new(MobileAmpelExtrasEvent_mt);
    self.className="MobileAmpelExtrasEvent";
    return self;
end;

function MobileAmpelExtrasEvent:new(object, red, orange, green)
    local self = MobileAmpelExtrasEvent:emptyNew()
	self.object = object;
    self.red = red;
    self.orange = orange;
    self.green = green;
	return self;
end;

function MobileAmpelExtrasEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.red = streamReadBool(streamId);
    self.orange = streamReadBool(streamId);
    self.green = streamReadBool(streamId);
    self:run(connection);
end;

function MobileAmpelExtrasEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.red);
    streamWriteBool(streamId, self.orange);
    streamWriteBool(streamId, self.green);
end;

function MobileAmpelExtrasEvent:run(connection)
	self.object:setAmpelLightState(self.red, self.orange, self.green, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(MobileAmpelExtrasEvent:new(self.object, self.red, self.orange, self.green), nil, connection, self.object);
    end;	
end;

function MobileAmpelExtrasEvent.sendEvent(vehicle, red, orange, green, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MobileAmpelExtrasEvent:new(vehicle, red, orange, green), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MobileAmpelExtrasEvent:new(vehicle, red, orange, green));
		end;
	end;
end;